/*
 * @(#)GetRedirectTest.java	1.5 96/11/23
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */
import java.awt.*;
import java.util.*;
import java.net.*;
import java.applet.*;
import java.awt.image.ImageObserver;

public class GetRedirectTest extends SecurityTest implements ImageObserver {

    public void test(Graphics g) throws java.io.IOException, MalformedURLException {
	String forbiddenRedirectedURL = app.getParameter("IllegalRedirectURL");
	Image image = app.getImage(new URL(forbiddenRedirectedURL));
	g.drawImage(image, 0, 0, this);
	try {
	    synchronized(this) {
		wait(5000);
	    }
	} catch (InterruptedException e) {}
	g.drawImage(image, 0, 0, this);
    }

    public synchronized boolean imageUpdate(Image img, int infoflags,
					    int x, int y,
					    int width, int height)
    {
	notify();
	return true;
    }
}

