/*
 * @(#)Patricide.java	1.5 97/03/03
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */
import java.awt.*;
import java.util.*;
import java.applet.*;
import java.io.*;

/**
 * See bugid 4016061
 *
 * An applet can continue to invoke getParent() in order to get its
 * grandparent, its great-grandparent, etc.   Then, it can use the
 * ancestors to change menu bars and other browser resources that shouldn't
 * be changeable from an applet.   Conceivably it could continue up the
 * parent chain until it reached the root and it could commit suicide and shut
 * down the browser. 
 * 
 * This is a security issue for appletviewer and for hotjava, but not for
 * netscape navigator, since NN isn't using java.awt.Frame to implement the
 * main browser frame. 
 * 
 * This is a known failure in JDK 1.1 but isn't serious.   It is slated to 
 * be fixed for HotJava FCS (JDK 1.1.1.) 
 *
 * mrm March 3, 1997 
 */
public class Patricide extends SecurityTest {

    public void test(Graphics g) {

	Component parent = this.app.getParent();

	if (parent != null) {
	    Component grandparent = parent.getParent();

	    if (grandparent != null) {
		
	    } else {
		/* Not successful in accessing grandparent */
		throw new SecurityException();
	    }
	}
    }
}
