/*
 * @(#)ExceptionOutputStream.java	1.3 96/11/23
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */
import java.io.OutputStream;
import java.io.IOException;


public
class ExceptionOutputStream extends OutputStream {
    /**
     * Writes a byte to the buffer.
     * @param b	the byte
     */
    public void write(int b) throws IOException
    {
	if (currentOffset >= exceptionOffset) {
	    throw new IOException("Debug exception");
	}
	currentOffset++;
    }

    private int exceptionOffset = 0;
    private int currentOffset = 0;
  
    public void setExceptionOffset(int offset)
    {
      exceptionOffset = offset;
      currentOffset = 0;
    }
  
}
